<template>
  <div class="main" v-if="'typeof weather.main!=undefined'">
    <div class="top">
      <p class="header">{{weatherData.name}}</p>
    </div>
    <div class="flex">
      <p class="day">{{dayOfTheWeek()}}, <span>{{date()}}</span></p>
      <p class="description">{{weatherData.weather[0].main}}</p>
    </div>

    <div class="flex">
      <p class="temp">Temprature: {{weatherData.main.temp}} &deg;C</p>
      <p class="temp">Humidity: {{weatherData.main.humidity}} %</p>
    </div>

    <div class="flex">
      <p class="sunrise-sunset">Sunrise: {{new Date(weatherData.sys.sunrise * 1000).toLocaleTimeString('fr-FR')}}</p>
      <p class="sunrise-sunset">Sunset: {{new Date(weatherData.sys.sunset * 1000).toLocaleTimeString('fr-FR')}}</p>
    </div>

  </div>
</template>

<script>
  export default {
    data() {
      return {
        api_key: "266c72295841df2e2463803e546335e0",
        url_base: "https://api.openweathermap.org/data/2.5/",
        weather_icon: "http://openweathermap.org/img/wn/",
        query: "",
        weatherData: {},
      };
    },
    methods: {
      getLocation() {
        navigator.geolocation.getCurrentPosition((position) => {
          this.fetchWeather(position.coords.latitude, position.coords.longitude)
        });
      },
      async fetchWeather(lat, lon) {
        await fetch(`${this.url_base}/weather/?lat=${lat}&lon=${lon}&units=metric&APPID=${this.api_key}`)
          .then(res => res.json())
          .then(result => {
            this.setResults(result);
            console.log(result);
          });
      },

      setResults(returnedResponse) {
        this.weatherData = returnedResponse;
      },

      dayOfTheWeek() {
        const dateObj = new Date();
        const days = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
        return days[dateObj.getDay()];
      },

      date() {
        const dateObj = new Date();
        return dateObj.getDate() + ' ' + dateObj.toLocaleString('en-us', { month: "short" }) + ' ' + dateObj.getFullYear();
      }
    },
    beforeMount() {
      this.getLocation();
    }
  };
</script>

<style scoped>
  @import url('https://fonts.googleapis.com/css2?family=Recursive&display=swap');

.main{
    width: 700px;
    border-radius: 20px;
    background-color: #01579b;
}

.top{
    height: 60px;
    background-color: #424242;
    color: whitesmoke;
    padding: 10px;
    border-radius: 20px 20px 0 0;
    font-family: 'Recursive', sans-serif;
    display: flex;
    justify-content: space-between;
}

.header{
    background-color: #424242;
    color: whitesmoke;
    margin: 10px 0px 0px 10px;
    font-size: 25px;
    border-radius: 20px 20px 0 0;
    font-family: 'Recursive', sans-serif;
}

.day{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 24px;
    font-weight: 600;
}

.temp{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 18px;
}

.flex{
    display: flex;
    justify-content: space-between;
}

.sunrise-sunset{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 16px;
}

.description{
    padding: 15px;
    color: whitesmoke;
    font-family: 'Recursive', sans-serif;
    font-size: 24px;
    font-weight: 600;
}
</style>
